@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!/sw/bin/perl
#line 14

$self = $0;
$self =~ s!^.*[/\\]!!;
$self =~ s!\.+(?:pl|sh|bat)?$!!i;

$show_path = 0;
$ignore_case = 0;

use Getopt::Long qw(:config bundling);

die "Usage: $self [-i] [-l] <perlregexp>\n"
    unless ( GetOptions('i' => \$ignore_case, 'l' => \$show_path) && (@ARGV == 1) );

$pattern = shift;

eval { $self =~ /$pattern/o; };

if ($@)
{
    $@ =~ s!\s+$!!;
    $@ =~ s!\s+at\s.+$!!;
    die "$self: $@\n";
}

@dirs = split(/:/, $ENV{'MANPATH'});

DIR:
foreach $dir (@dirs)
{
    next DIR unless -d $dir;
    unless (opendir(DIR, $dir))
    {
        warn "can't open dir '$dir': $!\n";
        next DIR;
    }
    @subdirs = readdir(DIR);
    unless (closedir(DIR))
    {
        warn "can't close dir '$dir': $!\n";
    }
    SUBDIR:
    foreach $item (@subdirs)
    {
        next SUBDIR if $item =~ /^\.\.?$/;
        $subdir = "$dir/$item";
        next SUBDIR unless -d $subdir;
        unless (opendir(SUBDIR, $subdir))
        {
            warn "can't open subdir '$subdir': $!\n";
            next SUBDIR;
        }
        @files = readdir(SUBDIR);
        unless (closedir(SUBDIR))
        {
            warn "can't close subdir '$subdir': $!\n";
        }
        FILE:
        foreach $item (@files)
        {
            next FILE if $item =~ /^\.\.?$/;
            $file = "$subdir/$item";
            next FILE unless (-f $file && -r $file);
            $item =~ s!\.\d$!!;
            if ($show_path)
            {
                if ($ignore_case) { print "$file\n" if $item =~ /$pattern/io; }
                else              { print "$file\n" if $item =~ /$pattern/o;  }
            }
            else
            {
                if ($ignore_case) { print "$item\n" if $item =~ /$pattern/io; }
                else              { print "$item\n" if $item =~ /$pattern/o;  }
            }
     
        }
    }
}

__END__

__END__
:endofperl
